#pragma once
#ifndef __TextFieldWidget_H__
#define __TextFieldWidget_H__

class TextFieldWidget
	: public Widget
{
public:
	TextFieldWidget(Vector2n Position);
	virtual ~TextFieldWidget();

	void Render() override;

	void ProcessTap() override;
	void ProcessCharacter(const int Character) override;

	void ProcessEvent(InputEvent & InputEvent) override;

private:
	struct ContentLine
	{
		std::string::size_type			m_StartPosition;
		decltype(m_StartPosition)		m_Length;

		ContentLine(decltype(m_StartPosition) StartPosition, decltype(m_Length) Length)
			: m_StartPosition(StartPosition),
			  m_Length(Length)
		{}
	};

	std::string							m_Content;
	std::vector<ContentLine>			m_ContentLines;
	decltype(ContentLine::m_Length)		m_MaxLineLength;

	std::string::size_type				m_CaretPosition;
	decltype(m_CaretPosition)			m_TargetCaretColumn;
	decltype(m_CaretPosition)			m_SelectionPosition;
};

#endif // __TextFieldWidget_H__
